The libextractor Library
************************

This manual is for libextractor (version 0.5.23, 2 July 2009), which is
GNU's library for meta data extraction.

   Copyright (C) 2007 Christian Grothoff

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU General Public License as
     published by the Free Software Foundation; either version 2 of the
     License, or (at your option) any later version. The text of the
     license can be found in the section entitled "Copying".

Appendices

Indices

1 Introduction
**************

libextractor is GNU's library for extracting meta data from files.
Meta data includes format information (such as mime type, image
dimensions, color depth, recording frequency), content descriptions
(such as document title or document description) and copyright
information (such as license, author and contributors).  Meta data
extraction is an inherently uncertain business -- a parse error can be
a corrupt file, an incompatibility in the file format version, an
entirely different file format or a bug in the parser.  As a result of
this uncertainty, libextractor deliberately avoids to ever report any
errors.  Unexpected file contents simply result in less or possibly no
meta data being extracted.

   libextractor uses plugins to handle various file formats.
Technically a plugin can support multiple file formats; however, most
plugins only support one particular format.  libextractor uses a
certain set of _default_ plugins.  Certain additional plugins are only
used if specifically requested.  Optional plugins exist for computing
various cryptographic hash functions (the hash of the file is returned
as meta data), thumbnail creation for images and full-text extraction
(based on language-specific dictionaries).  A few plugins exist to
manipulate results from other plugins, such as splitting meta data into
individual words at particular characters and converting the output to
lower case letters.

   libextractor is distributed with the `extract' command(1) which is a
command-line tool for extracting meta data.  `extract' is given a list
of filenames and prints the resulting meta data to the console.  The
`extract' source code also serves as an advanced example for how to use
libextractor.

   This manual focuses on providing documentation for writing software
with libextractor.  The only relevant parts for end-users are the
chapter on compiling and installing libextractor (see
Preparation.).  Also, the chapter on existing plugins maybe of
interest (see Existing Plugins.).  Additional documentation for
end-users can be find in the man page on `extract' (using man extract).

   libextractor is licensed under the GNU Public License.  The
developers have frequently received requests to license GNU
libextractor under alternative terms.  However, libextractor borrows
plenty of GPL-licensed code from various other projects.  Hence we
cannot change the license (even if we wanted to).(2)

   ---------- Footnotes ----------

   (1) Some distributions ship `extract' in a seperate package.

   (2) It maybe possible to switch to GPLv3 in the future.  For this,
an audit of the license status of our dependencies would be required.
The new code that was developed specifically for libextractor has
always been licensed under GPLv2 _or any later version_.

2 Preparation
*************

Compiling libextractor follows the standard GNU autotools build process
using `configure' and `make'.  For details, read the `INSTALL' file and
query ./configure --help for additional options.

   libextractor has various dependencies, some of which are optional.
You can find the current list specified in terms of Debian GNU/Linux
packages in `README.debian'.  Note that transitive dependencies are
_not_ listed.

   Once you have compiled and installed libextractor, you should have a
file `include/extractor.h' installed in your include directory.  This
file should be the starting point for your C and C++ development with
libextractor.  The build process also installs the `extract' binary and
man pages for `extract' and libextractor.  The `extract' man page
documents the `extract' tool.  The libextractor man page gives a brief
summary of the C API for libextractor.

   When you install libextractor, various plugins will be installed in
the `lib/libextractor/' directory.  The main library will be installed
as `lib/libextractor.so'.  Note that libextractor will attempt to find
the plugins relative to the path of the main library.  Consequently, a
package manager can move the library and its plugins to a different
location later -- as long as the relative path between the main library
and the plugins is preserved.  As a method of last resort, the user can
specify an environment variable LIBEXTRACTOR_PREFIX.  If libextractor
cannot locate a plugin, it will look in
LIBEXTRACTOR_PREFIX/lib/libextractor/.

3 Generalities
**************

Each public symbol exported by libextractor has the prefix EXTRACTOR_.
All-caps names are used for constants.  For the impatient, the minimal
C code for using libextractor (on the executing binary itself) looks
like this:

#include <extractor.h>
int main(int argc, char ** argv) {
  EXTRACTOR_ExtractorList * plugins
    = EXTRACTOR_loadDefaultLibraries();
  EXTRACTOR_KeywordList * keywords
    = EXTRACTOR_getKeywords(plugins, argv[0]);
  EXTRACTOR_printKeywords(stdout, keywords);
  EXTRACTOR_freeKeywords(keywords);
  EXTRACTOR_removeAll(plugins);
  return 0;
}

   libextractor defines three main data types.  Understanding these
types is key for programming with libextractor.

   First, EXTRACTOR_KeywordType is a C enum which defines a list of
over 100 different types of meta data.  The total number can differ
between different libextractor releases; the maximum value for the
current release can be obtained using the
EXTRACTOR_getHighestKeywordTypeNumber function.

   The function EXTRACTOR_getKeywordTypeAsString can be used to obtain
an English string `s' describing the meta data type.  The string maybe
translated into other languages using GNU gettext with the domain set
to libextractor (dgettext("libextractor", s)).

   Second, libextractor uses a linked list EXTRACTOR_KeywordList to
store extracted meta data.  The structure is extremely simple,
consisting of a field `keyword' which holds the meta data as a zero
terminated UTF-8 string, a field `keywordType' of type
EXTRACTOR_KeywordType which describes the type of the meta data and a
`next' pointer to the next meta data record (or NULL for the last
entry).

   Clients are allowed to directly access the keyword list.  After
returning the list to the client, libextractor makes no assumptions
about how the client may process the list.  The client is responsible
for freeing both the linked list and the keywords stored in the linked
list.  The EXTRACTOR_freeKeywords function provides a convenient way to
do so.

   Finally, the third data type used by libextractor is the
EXTRACTOR_ExtractorList.  This linked list is used to store information
about the plugins that libextractor is using to obtain meta data.  The
struct contains information identifying the plugin, a pointer to the
meta data extraction function provided by the plugin and options for
the plugin.  Most clients should never be concerned with the internals
of this type.

   Clients should use the EXTRACTOR_loadDefaultLibraries function to
create an extractor list with the default set of plugins.  Additional
functions are provided for loading optional plugins.  Once the meta
data extraction is complete, clients should call EXTRACTOR_removeAll to
unload the plugins and free the extractor list.  Note that loading and
unloading the plugins is a relatively costly operation.  If possible,
programmers should avoid needlessly loading and unloading the plugins.

   All of the functions for loading and unloading plugins, including
EXTRACTOR_loadDefaultLibraries and EXTRACTOR_removeAll, are
thread-safe, but not reentrant. The functions use operating system
specific calls to dynamically load and unload objects, and in many
cases, these calls are not thread-safe. In libextractor code, locking
is used to protect access to these operating system specific calls.

   Generally, libextractor is fully thread-safe and mostly reentrant.
All plugin code is required to be reentrant, so the same set of plugins
can be safely used concurrently by multiple threads. Reentrant
functions, naturally, do not protect their arguments (plugin or keyword
lists) against concurrent access. For further information on
libextractor's thread-safety and reentrancy, also see the following
chapters on libextractor usage.

4 Extracting meta data
**********************

The main functions for extracting keywords with libextractor are
EXTRACTOR_getKeywords and EXTRACTOR_getKeywords2.  The first argument
to both functions is an extractor list which specifies the set of
plugins that should be used for extracting meta data.   Both functions
return a linked list of keywords (of type EXTRACTOR_KeywordList). Also,
both functions are reentrant.

   The difference between the two functions is in how the file from
which the meta data should be obtained is specified. The
EXTRACTOR_getKeywords function simply takes the name of the file as its
second argument.  The EXTRACTOR_getKeywords2 function takes a
(read-only) buffer and its size (in bytes) as arguments, allowing meta
data extraction from memory.

   Meta data extraction should never really fail - at worst,
libextractor should return a NULL pointer indicating that no meta data
was found.  By design, libextractor should never crash or leak memory,
even given corrupt files as input.  Note however, that running
libextractor on a corrupt file system (or incorrectly mmaped files) can
result in the operating system sending a SIGBUS (bus error) to the
process.  libextractor will _not_ attempt to catch this signal and your
application is likely to crash.  Note again that this should only
happen if the file _system_ is corrupt (not if individual files are
corrupt).  If this is not acceptable, you might want to consider running
libextractor out-of-process (as done, for example, by doodle
(http://gnunet.org/doodle/)).

4.1 Customizing the Plugins
===========================

The functions described in this section can be used to control which
plugins are loaded and in which order they are executed.  This provides
more control than simply sticking to the default list.  It is
recommended that clients start by loading the default plugins and then
allow the user to perform further customizations using command-line
options or a configuration file.

   Like EXTRACTOR_loadDefaultLibraries and EXTRACTOR_removeAll, these
functions are thread-safe, but not reentrant.

   The EXTRACTOR_addLibrary function can be used to add a single plugin
to the front of the list of already loaded plugins.

   Use EXTRACTOR_addLibraryLast to add a plugin to the end of the list
of plugins.  Plugins at the end can benefit from analyses performed by
plugins earlier (such as mime-type detection).  This can be useful to
avoid more expensive processing.  Some plugins need to be loaded last
since they transform the keyword list.  For example, the split plugin
tokenizes the meta data returned by other plugins.  Since this plugin
needs the keywords generated by the other plugins as its' input, it
must be run last in order to ensure that it is applied to all keywords.

   The EXTRACTOR_removeLibrary function can be used to unload a
specific plugin.

   The EXTRACTOR_loadConfigLibraries provides a simple interface for
highly customized loading of plugins.  The provided configuration
string can specify multiple plugins (seperated by colons) with optional
arguments to the plugins (in parenteses after the plugin name).  By
default the plugins are pre-pended to the plugin list in the order that
the plugins are processed; however, by prefixing the plugin name with a
minus-sign that particular library will be appended to the list.

5 Language bindings
*******************

libextractor works immediately with C and C++ code.  Bindings for Java,
Ruby, Perl, PHP and Python are available for download from the main
libextractor website.  Documentation for these bindings (if available)
is part of the downloads for the respective binding.  In all cases, a
full installation of the C library is required before the binding can
be installed.

6 Utility functions
*******************

This chapter describes various utility functions for libextractor
usage. All of the functions are reentrant.

6.1 Utility Constants
=====================

The constant EXTRACTOR_VERSION is a hexadecimal representation of the
version number of the installed libextractor header.  The hexadecimal
format is 0xAABBCCDD where AA is the major version (so far always 0),
BB is the minor version, CC is the revision and DD the patch number.
For example, for version 0.5.18, we would have AA=0, BB=5, CC=18 and
DD=0.  Minor releases such as 0.5.18a or significant changes in
unreleased versions would be marked with DD=1 or higher.

   If your code needs to find out what the set of default plugins that
would be loaded with EXTRACTOR_loadDefaultLibraries is, the function
EXTRACTOR_getDefaultLibraries returns a constant string which follows
the format of EXTRACTOR_loadConfigLibraries and specifies the set of
default plugins for this version of libextractor.

6.2 Misc Keyword List
=====================

This section describes a couple of convenience functions for
manipulating the keyword list.

   The EXTRACTOR_printKeywords is a simple function which prints the
meta data found with libextractor to a file.  The function is mostly
useful for debugging and as an example for how to manipulate the
keyword list.

   The EXTRACTOR_countKeywords returns the number of keywords found.
It simply traverses the linked list and determines its length.

6.3 Cleaning up the Keyword List
================================

The EXTRACTOR_removeDuplicateKeywords function can be used to remove
duplicate keywords.  This is useful since the same keyword can be
extracted by multiple plugins.  In addition to the keyword list, the
function requires an argument options which is used to specify what
should be considered a duplicate.  The value zero should be used if
only exact matches (same keyword string and same meta data type) should
be removed.  Use EXTRACTOR_DUPLICATES_TYPELESS in order to remove
duplicate keywords even if the meta data types are different.  Use
EXTRACTOR_DUPLICATES_REMOVE_UNKNOWN to remove entries where the
keywords match exactly and one of the keyword types is
EXTRACTOR_UNKNOWN.  Given the choice, EXTRACTOR_removeDuplicateKeywords
will always prefer to remove the duplicate keyword with the
EXTRACTOR_UNKNOWN and EXTRACTOR_SPLIT types.

   The EXTRACTOR_removeEmptyKeywords simply removes meta data entries
that are empty strings.

   The EXTRACTOR_removeKeywordsOfType function can be used to remove
all keywords of a particular meta data type.

6.4 Finding Keywords
====================

The EXTRACTOR_extractLast function returns the last keyword value in
the linked list that has the given meta data type.

   The EXTRACTOR_extractLastByString works exactly like
EXTRACTOR_extractLast except that the meta data type is specified using
the corresponding string value.

6.5 Binary Meta data
====================

libextractor supports binary meta data.  At this point, binary meta
data is rarely encountered - the default meta data plugins do not
generate binary meta data.  However, you can load one of the
thumbnail-plugins to generate thumbnails for various images.  These
thumbnails are binary meta data.  In the future it is conceivable that
additional binary meta data extractors will be implemented.

   Since the simple linked list of keywords that is used by the
libextractor API only contains 0-terminated strings, binary meta data
cannot be directly returned as-is by the plugins.  Also, if binary meta
data is returned, the keyword string does not point to the usual UTF-8
encoded string.  Applications must be aware of this in order to avoid
printing binary meta data by accident as if it was UTF-8.

   The EXTRACTOR_isBinaryType function is used to test if a particular
meta data type contains binary meta data.  If this function returns 0,
the client can be certain that the keyword is UTF-8 and not binary.

   In order to handle zero-bytes in binary data, libextractor encodes
binary data in a particular format.  The function
EXTRACTOR_binaryDecode can be used to convert the 0-terminated string
back to the standard binary format.

   The EXTRACTOR_binaryEncode function converts binary data into
libextractor's internal 0-terminated binary format.  This function is
mostly useful for writing plugins that need to return binary meta data.

7 Existing Plugins
******************

HTML, PDF, PS, OLE2 (DOC, XLS, PPT), OpenOffice (sxw), StarOffice (sdw),
DVI, MAN, MP3 (ID3v1 and ID3v2), NSF (NES Sound Format), SID, OGG, WAV,
EXIV2, JPEG, GIF, PNG, TIFF, DEB, RPM, TAR(.GZ), ZIP, ELF, REAL, RIFF
(AVI), MPEG, QT and ASF.

8 Writing new Plugins
*********************

Writing a new plugin for libextractor usually requires writing of or
interfacing with an actual parser for a specific format.  How this is
can be accomplished depends on the format and cannot be specified in
general.  However, care should be taken for the code to be reentrant
and highly fault-tolerant, especially with respect to malformed inputs.

   Plugins should start by verifying that the header of the data matches
the specific format and immediately return if that is not the case.
Even if the header matches the expected file format, plugins must not
assume that the remainder of the file is well formed.

   The plugin library must be called libextractor_XXX.so, where XXX
denotes the file format of the plugin. The library must export a method
libextractor_XXX_extract, with the following signature:
struct EXTRACTOR_Keywords *
libextractor_XXX_extract
   (const char * filename,
    const char * data,
    size_t size,
    struct EXTRACTOR_Keywords * prev,
    const char * options);

   The argument `filename' specifies the name of the file being
processed and maybe NULL.  `data' is a pointer to the typically memory
mapped contents of the file.  Note that plugins cannot ignore the const
annotation since the memory mapping may have been done read-only (and
thus writes to this page will result in an error).  The `size' argument
specifies the size of the `data' buffer in bytes.

   `prev' is the list of keywords extracted so far by other plugins for
the file.  The function is expected to return an updated list of
keywords.  If the format does not match the expectations of the plugin,
`prev' is returned.  Most plugins use a function such as addKeyword to
extend the list:

static void addKeyword
   (struct EXTRACTOR_Keywords ** list,
    const char * keyword,
    EXTRACTOR_KeywordType type)
{
  EXTRACTOR_KeywordList * next;
  next = malloc(sizeof(EXTRACTOR_KeywordList));
  next->next = *list;
  next->keyword = strdup(keyword);
  next->keywordType = type;
  *list = next;
}

   A typical use of addKeyword is to add the MIME type once the file
format has been established (beyond reasonable doubt).

9 Internal utility functions
****************************

Various libextractor plugins make use of the internal `convert.h'
header which defines a function EXTRACTOR_common_convert_to_utf8 which
can be used to easily convert text from any character set to UTF-8.
This conversion is important since the linked list of keywords that is
returned by libextractor is expected to contain only UTF-8 strings.
Naturally, proper conversion may not always be possible since some file
formats fail to specify the character set.  In that case, it is often
better to not convert at all.

   The arguments to EXTRACTOR_common_convert_to_utf8 are the input
string (which does _not_ have to be zero-terminated), the length of the
input string, and the character set (which _must_ be zero-terminated).
Which character sets are supported depends on the platform, a list can
generally be obtained using the `iconv -l' command.  The return value
from EXTRACTOR_common_convert_to_utf8 is a zero-terminated string in
UTF-8 format.  The responsibility to free the string is with the
caller, so storing the string in the keyword list is acceptable.

10 Reporting bugs
*****************

libextractor uses the Mantis bugtracking system
(http://gnunet.org/mantis/).  If possible, please report bugs there.
You can also e-mail the libextractor mailinglist at
`libextractor@gnu.org'.

Appendix A GNU GENERAL PUBLIC LICENSE
*************************************

                         Version 2, June 1991

     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

A.0.1 Preamble
--------------

The licenses for most software are designed to take away your freedom
to share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it in
new free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
  1. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program",
     below, refers to any such program or work, and a "work based on
     the Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification".)  Each
     licensee is addressed as "you".

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  2. You may copy and distribute verbatim copies of the Program's
     source code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  3. You may modify your copy or copies of the Program or any portion
     of it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program
          or any part thereof, to be licensed as a whole at no charge
          to all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not
     apply to those sections when you distribute them as separate
     works.  But when you distribute the same sections as part of a
     whole which is a work based on the Program, the distribution of
     the whole must be on the terms of this License, whose permissions
     for other licensees extend to the entire whole, and thus to each
     and every part regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on
     a volume of a storage or distribution medium does not bring the
     other work under the scope of this License.

  4. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either
     source or binary form) with the major components (compiler,
     kernel, and so on) of the operating system on which the executable
     runs, unless that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  5. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

  6. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this
     License to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  7. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program
     subject to these terms and conditions.  You may not impose any
     further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties to this License.

  8. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who
     receive copies directly or indirectly through you, then the only
     way you could satisfy both it and this License would be to refrain
     entirely from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  9. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

 10. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies
     to it and "any later version", you have the option of following
     the terms and conditions either of that version or of any later
     version published by the Free Software Foundation.  If the Program
     does not specify a version number of this License, you may choose
     any version ever published by the Free Software Foundation.

 11. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted
     by the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                                NO WARRANTY
 12. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
     WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
     NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
     QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
     PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
     SERVICING, REPAIR OR CORRECTION.

 13. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License along
     with this program; if not, write to the Free Software Foundation, Inc.,
     59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 19YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands `show w' and `show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than `show w' and `show
c'; they could even be mouse-clicks or menu items--whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.